<template>
  <q-page class="q-pa-lg bg-grey-1" role="presentation">
    <q-splitter class="splitscreen__splitter" v-model="panelWidth" :limits="[50,100]">
      <template v-slot:before>
        <div v-if="itemtype">
          <q-card class="q-pb-lg shadow-1" bordered role="grid" aria-label="itemtype">
            <q-card-section class="text-primary text-weight-bold itemtype__heading" role="heading">
              <div><span>{{ itemtype.name }}</span></div>
            </q-card-section>
            <div class="row" role="row">
              <div class="col-3 label" role="rowheader">ID</div>
              <div class="col-8 value detail_bg" role="cell">{{ itemtype.id }}</div>
            </div>
            <div class="row" role="row">
              <div class="col-3 label" role="rowheader">Name</div>
              <div class="col-8 value detail_bg" role="cell">{{ itemtype.name }}</div>
            </div>
            <div class="row" role="row">
              <div class="col-3 label" role="rowheader">Domain</div>
              <div class="col-8 value detail_bg" role="cell">{{ itemtype.domain }}</div>
            </div>
            <div class="row" role="row">
              <div class="col-3 label" role="rowheader">Base</div>
              <div class="col-8 value detail_bg" role="cell">{{ itemtype.base }}</div>
            </div>
            <div class="row" role="row">
              <div class="col-3 label" role="rowheader">Inheritance type</div>
              <div class="col-8 value detail_bg" role="cell">{{ itemtype.inheritance_type }}</div>
            </div>
            <div class="row" role="row">
              <div class="col-3 label" role="rowheader">Total digits</div>
              <div class="col-8 value detail_bg" role="cell">{{ itemtype.total_digits }}</div>
            </div>
            <div class="row" role="row">
              <div class="col-3 label" role="rowheader">Fraction digits</div>
              <div class="col-8 value detail_bg" role="cell">{{ itemtype.fraction_digits }}</div>
            </div>
            <div class="row" role="row">
              <div class="col-3 label" role="rowheader">Min inclusive</div>
              <div class="col-8 value detail_bg" role="cell">{{ itemtype.min_inclusive }}</div>
            </div>
            <div class="row" role="row">
              <div class="col-3 label" role="rowheader">Max inclusive</div>
              <div class="col-8 value detail_bg" role="cell">{{ itemtype.max_inclusive }}</div>
            </div>

            <template v-if="itemtype.inheritance_type !== 'extends'">
              <div class="row" role="row">
                <div class="col-3 label" role="rowheader">Restriction type</div>
                <div class="col-8 value detail_bg" role="cell">{{ itemtype.restriction_type }}</div>
              </div>
              <div class="row" role="row">
                <div class="col-3 label" role="rowheader">Restriction pattern</div>
                <div class="col-8 value detail_bg" role="cell">{{ itemtype.restriction_pattern }}</div>
              </div>
              <div class="row" role="row">
                <div class="col-3 label" role="rowheader">Restriction min length</div>
                <div class="col-8 value detail_bg" role="cell">{{ itemtype.restriction_min_length }}</div>
              </div>
              <div class="row" role="row">
                <div class="col-3 label" role="rowheader">Restriction max length</div>
                <div class="col-8 value detail_bg" role="cell">{{ itemtype.restriction_max_length }}</div>
              </div>
            </template>
            <template v-if="itemtype.enumeration">
              <div class="row" role="row">
                <div class="col-3 label">Enumeration</div>
                <div class="col-8 value detail_bg" role="cell">
                  <q-expansion-item dense default-opened label="Options">
                    <q-item dense v-for="(option, index) in itemtype.enumeration" :key="index">
                      <table>
                        <tr>
                          <th colspan="2">{{ option.value }}</th>
                        </tr>
                        <template v-if="option.labels">
                          <tr v-for="(label, ind) in option.labels" :key="ind">
                            <td class="tiny">{{ label.lang }}</td>
                            <td>{{ label.label_text }}</td>
                          </tr>

                        </template>
                      </table>
                    </q-item>
                  </q-expansion-item>
                </div>
              </div>
            </template>
          </q-card>
          <q-card v-if="itemtype.number_of_concepts" class="q-pb-lg q-mt-md shadow-1 full-width" bordered role="grid">
            <div class="q-pa-md">Aantal concepten met dit datatype: <strong>{{ itemtype.number_of_concepts }}</strong>
            </div>
            <div class="q-pa-md full-width">
              <ItemtypeBackref :dts_name="dts_name" :itemtype_name="itemtype_name" :nt_version="nt_version"
                               v-on:conceptClicked="concept_clicked"></ItemtypeBackref>
            </div>
          </q-card>
        </div>

      </template>
      <template v-slot:separator>
      </template>
      <template v-slot:after>
        <div v-if="node" role="region" aria-label="Detail gekozen cell">
          <CellValue :node="node" v-on:close_detail="close_detail"></CellValue>
        </div>
      </template>

    </q-splitter>

  </q-page>
</template>

<script>
import {api} from 'boot/axios'
import ItemtypeBackref from "components/ItemtypeBackref";
import CellValue from "components/CellValue";

export default {
  name: "ItemtypeDetail",
  components: {CellValue, ItemtypeBackref},
  props: {
    itemtype_name: String,
    dts_name: String,
    nt_version: String,
  },
  data() {
    return {
      itemtype: undefined,
      node: undefined,
      panelWidth: 70,
    }
  },
  watch: {
    itemtype_name: function () {
      this.fetchdata()
    }
  },
  mounted() {
    this.fetchdata()
  },
  methods: {
    fetchdata: function () {
      if (this.itemtype_name) {
        api
          .get("/dts/" + this.dts_name + '/itemtypes/' + this.itemtype_name, {params: {nt_version: this.nt_version}})
          .then(response => {
            this.itemtype = response.data[0]
          })
      }
    },
    concept_clicked: function (concept) {
      this.node = {concept: concept}
      if (this.panelWidth === 100) {
        this.panelWidth = 50
      }
    },
    close_detail: function () {
      this.panelWidth = 100
    },
  }
}
</script>

<style scoped lang="scss">
.itemtype__heading {
  border-bottom: 1px solid $primary;
  font-size: 20px;
  margin-bottom: 10px;
}

.value {
  border-radius: 5px;
  padding: 5px 0 5px 10px;
}

.row {
  padding: 5px 0 0 0;
}

.label {
  padding: 5px 0 5px 10px;
}

table {
  border-spacing: 5px;
  width: 100%;
}

th {
  text-align: left;
}

td.tiny {
  width: 10%;
}
</style>
